C**************************************************************************
      COMPLEX FUNCTION AINTERPO3DBIG(NSAMA,IPAD,A3DF,A3DS,X,Y,Z)
C**************************************************************************
C     Used in funct PRES, and subr PRESB, CCP, PEXTRACT.	
C**************************************************************************
      IMPLICIT NONE
      INTEGER NSAM,JC,IPAD,NSAMA
      INTEGER L,M,N,LL,MM,NN,IS,ID,NSAMH
      REAL X,Y,Z
      COMPLEX A3DF(*),A3DS(*),SAMP
C**************************************************************************
      NSAM=IPAD*NSAMA
      SAMP=CMPLX(0.0,0.0)
      JC=NSAM/2+1
      NSAMH=NSAM/2
      L=NINT(IPAD*X)
      M=NINT(IPAD*Y)
      N=NINT(IPAD*Z)
      IF (L.GE.0) THEN
        LL=L+1
        MM=M+1
        IF (MM.LT.1) MM=MM+NSAM
        NN=N+1
        IF (NN.LT.1) NN=NN+NSAM
        IF (LL.NE.JC) THEN
      	  ID=LL+NSAMH*((MM-1)+NSAM*(NN-1))
          SAMP=SAMP+A3DF(ID)
        ELSE
      	  IS=MM+NSAM*(NN-1)
          SAMP=SAMP+A3DS(IS)
        ENDIF
      ELSE
        LL=-L+1
        MM=-M+1
        IF (MM.LT.1) MM=MM+NSAM
        NN=-N+1
        IF (NN.LT.1) NN=NN+NSAM
        IF (LL.NE.JC) THEN
      	  ID=LL+NSAMH*((MM-1)+NSAM*(NN-1))
          SAMP=SAMP+CONJG(A3DF(ID))
        ELSE
      	  IS=MM+NSAM*(NN-1)
          SAMP=SAMP+CONJG(A3DS(IS))
        ENDIF
      ENDIF
      AINTERPO3DBIG=SAMP
      RETURN
      END
