C**************************************************************************
      SUBROUTINE CORRECT3D_C(NSAM,SINCLUT,A3DV,IRAD)
C**************************************************************************
C     Corrects 3D volume for fall-off at edges due to
C     interpolation kernel in PEXTRACT - helical version
C     Used in frealign
C**************************************************************************
      IMPLICIT NONE
C
      INTEGER NSAM,I,J,K,IRAD,NMID,ID
      REAL SINCLUT(*),A3DV(*),A(3),BOXFT_LUT
C
      NMID=NSAM/2+1
      A(3)=0.0
      DO 10 I=1,NSAM
        A(1)=IRAD*REAL(I-NMID)/NSAM
        DO 10 J=1,NSAM
          A(2)=IRAD*REAL(J-NMID)/NSAM
          DO 10 K=1,NSAM
            ID=I+NSAM*(J-1+NSAM*(K-1))
            A3DV(ID)=A3DV(ID)/BOXFT_LUT(A,SINCLUT)
10    CONTINUE
C
      RETURN
      END
