C -----------------------------------------------------------------
	SUBROUTINE A3D3(NSET,ISWITCH,NSAM,IRAD,RI,RREC,
     +           AMAGP,DATC,DATQ,CTFF,CTFS,ASUM,VSUM,PSUM,
     +           C3DF,KSUM,
     +           PHI,THETA,PSI,DSHX,DSHY,PRESA,PBC,BOFF,
     +           A3DF,A3DS,S3DF,S3DS,STD,D3DF,D3DS,V3DF,
     +           V3DS,VTD,
     +           NN1,MAXSET,SINCLUT,IRADA,IPAD,THETATR,
     +           IEWALD,C3DS,
     +           NSYM,ISYM,JSYM,SYMOP,
     +           NNSTAT,NKSUM,IFSC,IMP,PSIZE,
     +           ASYM,ALPHA,RISE,NU,HSTART)
C -----------------------------------------------------------------
C         Put alternating particles into A3 or D3
C	  Used in LMAIN
C	  Calls PINSERT
C -----------------------------------------------------------------
	IMPLICIT NONE
	INTEGER NN1,PBC,IRAD,NSAM,ISWITCH,MAXSET,NSET
	INTEGER KSUM(*),IPAD,IRADA,NSYM,ISYM(*),NU
        INTEGER IEWALD,IMP,JSYM(*),IFSC,NNSTAT,HSTART
        INTEGER*8 NKSUM
	REAL RREC(*),AMAGP,DSHX,DSHY,BOFF,RI
	REAL S3DF(*),S3DS(*),SYMOP(3,3,*)
	REAL V3DF(*),V3DS(*),PSIZE
        REAL ASUM(*),VSUM(*),PSUM(*)
	REAL PSI,THETA,PHI,PRESA,SINCLUT(*)
        REAL THETATR,ALPHA,RISE
	DOUBLEPRECISION STD,VTD
	COMPLEX CTFF(*),CTFS(*)
	COMPLEX DATC(*),DATQ(*),C3DF(*)
        COMPLEX A3DF(*),A3DS(*)
        COMPLEX D3DF(*),D3DS(*),C3DS(*)
        CHARACTER ASYM*3
C -----------------------------------------------------------------
        IF (ISWITCH.EQ.0) THEN
C
          IF (ASYM(1:1).EQ.'H') THEN
C
          CALL PINSERT_C(NSAM,IRAD,RI,RREC(NSET),AMAGP,DATC,
     +    DATQ,CTFF,CTFS,A3DF,A3DS,S3DF,S3DS,A3DF,A3DS,S3DF,
     +    S3DS,STD,PHI,THETA,PSI,DSHX,DSHY,PRESA,PBC,
     +    BOFF,ASUM,VSUM,PSUM,C3DF,KSUM,1,SINCLUT,
     +    IRADA,IPAD,THETATR/AMAGP,IEWALD,C3DS,
     +    NSYM,ISYM,JSYM,SYMOP,NNSTAT,NKSUM,IMP,PSIZE,
     +    ALPHA,RISE,NU,HSTART)
C
          ELSE
C
          CALL PINSERT(NSAM,IRAD,RI,RREC(NSET),AMAGP,DATC,DATQ,
     +    CTFF,CTFS,A3DF,A3DS,S3DF,S3DS,A3DF,A3DS,S3DF,S3DS,
     +    STD,PHI,THETA,PSI,DSHX,DSHY,PRESA,PBC,BOFF,
     +    ASUM,VSUM,PSUM,C3DF,KSUM,1,SINCLUT,IRADA,IPAD,
     +    THETATR/AMAGP,IEWALD,C3DS,NSYM,ISYM,
     +    JSYM,SYMOP,NNSTAT,NKSUM,IMP)
C
          ENDIF
C
          IF (IFSC.LE.2) ISWITCH=1
        ELSE
          IF (IFSC.EQ.0) THEN
C
          IF (ASYM(1:1).EQ.'H') THEN
C
          CALL PINSERT_C(NSAM,IRAD,RI,RREC(NSET),AMAGP,DATC,
     +    DATQ,CTFF,CTFS,D3DF,D3DS,V3DF,V3DS,D3DF,D3DS,V3DF,
     +    V3DS,VTD,PHI,THETA,PSI,DSHX,DSHY,PRESA,PBC,
     +    BOFF,ASUM,VSUM,PSUM,C3DF,KSUM,1,SINCLUT,
     +    IRADA,IPAD,THETATR/AMAGP,IEWALD,C3DS,
     +    NSYM,ISYM,JSYM,SYMOP,NNSTAT,NKSUM,IMP,PSIZE,
     +    ALPHA,RISE,NU,HSTART)
C
          ELSE
C
          CALL PINSERT(NSAM,IRAD,RI,RREC(NSET),AMAGP,DATC,DATQ,
     +    CTFF,CTFS,D3DF,D3DS,V3DF,V3DS,D3DF,D3DS,V3DF,V3DS,
     +    VTD,PHI,THETA,PSI,DSHX,DSHY,PRESA,PBC,BOFF,
     +    ASUM,VSUM,PSUM,C3DF,KSUM,1,SINCLUT,IRADA,IPAD,
     +    THETATR/AMAGP,IEWALD,C3DS,NSYM,ISYM,
     +    JSYM,SYMOP,NNSTAT,NKSUM,IMP)
C
          ENDIF
C
          ENDIF
          ISWITCH=0
        ENDIF
	RETURN
	END
