C**************************************************************************
      COMPLEX FUNCTION AINTERPO3DS(NSAM,IRAD,A3DF,A3DS,
     .                             XX,YY,ZZ,SINCLUT,IPAD)
C**************************************************************************
C     Uses function  BOX FT_LUT.
C     Used in funct PRES, and subr PRESB, CCP, PEXTRACT and APPLYSYMC.	
C**************************************************************************
      IMPLICIT NONE
      INTEGER NSAM,IRAD,LS,LT,NS,NT,MS,MT,JC
      INTEGER L,M,N,LL,MM,NN,IS,ID,NSAMH,IPAD
      REAL X,Y,Z,PI,ARG(3),BOXFT,BOXFTV,BOXFT_LUT,SINCLUT(*)
      REAL XX,YY,ZZ
      PARAMETER  (PI=3.1415926535897)
      COMPLEX A3DF(*),A3DS(*),SAMP
C**************************************************************************
      SAMP=CMPLX(0.0,0.0)
      JC=NSAM/2+1
      NSAMH=NSAM/2
      X=IPAD*XX
      Y=IPAD*YY
      Z=IPAD*ZZ
      LS=INT(X)-IRAD+1
      IF (X.LT.0.0) LS=LS-1
      IF (LS.LT.-JC) LS=-JC+1
      LT=INT(X)+IRAD
      IF (X.LT.0.0) LT=LT-1
      IF (LT.GE.JC) LT=JC-1
      MS=INT(Y)-IRAD+1
      IF (Y.LT.0.0) MS=MS-1
      IF (MS.LE.-JC) MS=-JC+1
      MT=INT(Y)+IRAD
      IF (Y.LT.0.0) MT=MT-1
      IF (MT.GE.JC) MT=JC-1
      NS=INT(Z)-IRAD+1
      IF (Z.LT.0.0) NS=NS-1
      IF (NS.LE.-JC) NS=-JC+1
      NT=INT(Z)+IRAD
      IF (Z.LT.0.0) NT=NT-1
      IF (NT.GE.JC) NT=JC-1
C  remove multiplication by PI after version 4.05
      DO 40 L=LS,LT
C  division by IPAD wrong, removed (Chuck Sindelar, 18.9.08)
            ARG(1)=(X-L)
C            ARG(1)=(X-L)/IPAD
C            ARG(1)=(X-L)*PI
        DO 40 M=MS,MT
            ARG(2)=(Y-M)
C            ARG(2)=(Y-M)/IPAD
C            ARG(2)=(Y-M)*PI
          DO 40 N=NS,NT
            ARG(3)=(Z-N)
C            ARG(3)=(Z-N)/IPAD
C            ARG(3)=(Z-N)*PI
	    BOXFTV=BOXFT_LUT(ARG,SINCLUT)
C            BOXFTV=BOXFT(ARG)
            IF (L.GE.0) THEN
              LL=L+1
              MM=M+1
              IF (MM.LT.1) MM=MM+NSAM
              NN=N+1
              IF (NN.LT.1) NN=NN+NSAM
              IF (LL.NE.JC) THEN
      		ID=LL+NSAMH*((MM-1)+NSAM*(NN-1))
                SAMP=SAMP+A3DF(ID)*BOXFTV
              ELSE
      		IS=MM+NSAM*(NN-1)
                SAMP=SAMP+A3DS(IS)*BOXFTV
              ENDIF
            ELSE
              LL=-L+1
              MM=-M+1
              IF (MM.LT.1) MM=MM+NSAM
              NN=-N+1
              IF (NN.LT.1) NN=NN+NSAM
              IF (LL.NE.JC) THEN
      		ID=LL+NSAMH*((MM-1)+NSAM*(NN-1))
                SAMP=SAMP+CONJG(A3DF(ID)*BOXFTV)
              ELSE
      		IS=MM+NSAM*(NN-1)
                SAMP=SAMP+CONJG(A3DS(IS)*BOXFTV)
              ENDIF
            ENDIF
40    CONTINUE
      AINTERPO3DS=SAMP
      RETURN
      END
