C -----------------------------------------------------------------------------
      SUBROUTINE APPLYCREF(NSAM,A3DF,A3DS,FSC)
C -----------------------------------------------------------------------------
C       APPLY WINER FILTER TO VOLUME
C       Used in Frealign
C -----------------------------------------------------------------------------
        IMPLICIT NONE
C
        INTEGER L,LL,M,MM,N,NN,JC,NSAM,IS,ID
        INTEGER JRAD2,ILIM,NSAMH
        REAL FSC(*),F
        COMPLEX A3DF(*),A3DS(*)
C -----------------------------------------------------------------------------
        NSAMH=NSAM/2
        JC=NSAMH+1
        ILIM=NSAMH**2
        DO 61 L=1,JC
          LL=L-1
          DO 61 M=1,NSAM
            MM=M-1
            IF (MM.GE.JC) MM=MM-NSAM
            DO 61 N=1,NSAM
              NN=N-1
              IF (NN.GE.JC) NN=NN-NSAM
              JRAD2=LL**2+MM**2+NN**2
              F=0.0
              IF (JRAD2.LE.ILIM) F=ABS(FSC(INT(SQRT(REAL(JRAD2)))+1))
              IF (L.NE.JC) THEN
                ID=L+NSAMH*((M-1)+NSAM*(N-1))
                IF(JRAD2.LE.ILIM) THEN
                  A3DF(ID)=A3DF(ID)
     .              *SQRT(2.0*F/(1.0+F))
                ELSE
                  A3DF(ID)=CMPLX(0.0,0.0)
                ENDIF
              ELSE
                IS=M+NSAM*(N-1)
                IF(JRAD2.LE.ILIM) THEN
                  A3DS(IS)=A3DS(IS)
     .              *SQRT(2.0*F/(1.0+F))
                ELSE
                  A3DS(IS)=CMPLX(0.0,0.0)
                ENDIF
              ENDIF
61      CONTINUE
        RETURN
        END

