C -----------------------------------------------------------
      SUBROUTINE PAD(NSAM,IPAD,DATA,SPEQ,OUTD,OUTQ)
C -----------------------------------------------------------
C     Pad particle by factor IPAD (particle origin at (1,1))
C -----------------------------------------------------------
      IMPLICIT NONE
C
      INTEGER NSAM,I,J,II,JJ,ID,ID4,IPAD,NSAM4
      INTEGER NSAMH
      REAL CIRC,DATA(*),OUTD(*),SCAL,A
      COMPLEX SPEQ(*),OUTQ(*)
C -----------------------------------------------------------
C
      NSAM4=IPAD*NSAM
      NSAMH=NSAM/2
      SCAL=NSAM*NSAM/2
      DO 75 I=1,NSAM4*NSAM4
        OUTD(I)=0.0
75    CONTINUE
      DO 71 I=1,NSAM*NSAM
        OUTD(I)=DATA(I)/SCAL
71    CONTINUE
      DO 74 I=1,NSAM
        OUTQ(I)=SPEQ(I)/SCAL
74    CONTINUE
      CALL RLFT3(OUTD,OUTQ,NSAM,NSAM,1,-1)
C
      CIRC=0.0
      DO 70 I=1,NSAM
        DO 70 J=1,NSAM
          IF ((I.EQ.NSAM/2+1).OR.(J.EQ.NSAM/2+1)
     +       .OR.(I.EQ.NSAM/2).OR.(J.EQ.NSAM/2)) THEN
            ID=I+NSAM*(J-1)
            CIRC=CIRC+OUTD(ID)
          ENDIF
70    CONTINUE
      CIRC=CIRC/(4*NSAM-4)
C
      DO 72 I=1,NSAM4*NSAM4
        OUTD(I)=OUTD(I)+CIRC
72    CONTINUE
      DO 73 J=NSAM,1,-1
        JJ=J
        IF (JJ.GT.NSAMH) JJ=JJ+NSAM4-NSAM
        DO 73 I=NSAM,1,-1
          II=I
          IF (II.GT.NSAMH) II=II+NSAM4-NSAM
          ID=I+NSAM*(J-1)
          ID4=II+NSAM4*(JJ-1)
          A=OUTD(ID)-CIRC
          OUTD(ID)=CIRC
          OUTD(ID4)=A
73    CONTINUE
C
      CALL RLFT3(OUTD,OUTQ,NSAM4,NSAM4,1,1)
C
      RETURN
      END
